Option Explicit On 
Option Strict On

Namespace VB21.Day03

    Module Payment

        Private dblAnnualInterest As Double = 0
        Private iYears As Integer = 0
        Private decLoanAmount As Decimal = 0
        Private decMonthlyDeposit As Decimal = 0

        Public Sub Main()
            Dim decResult As Decimal

            'get input values
            GetInputValues()

            'calculate 
            decResult = CalculatePayment(decLoanAmount, dblAnnualInterest, iYears)

            'output result
            DisplayResults(decResult)

        End Sub

        Private Function CalculatePayment(ByVal LoanAmount As Decimal, ByVal AnnualInterest As Double, ByVal Years As Integer) As Decimal
            'divide by 1200 to make it percent and per month
            Dim decMonthlyInterest As Decimal = CDec(AnnualInterest / 1200)
            Dim iMonths As Integer = Years * 12
            Dim decTemp As Decimal
            Dim decReturn As Decimal


            'we'll need this value in a couple of places
            decTemp = CDec(((1 + decMonthlyInterest) ^ iMonths))
            decReturn = LoanAmount * (decMonthlyInterest * decTemp / (decTemp - 1))
            Return decReturn

        End Function

        Private Sub GetInputValues()
            Console.WriteLine()
            decLoanAmount = CDec(GetValue("Loan Amount: "))
            dblAnnualInterest = CDbl(GetValue("Annual Interest (e.g. for 5%, enter 5): "))
            iYears = CInt(GetValue("Years of loan: "))
            Console.WriteLine()
        End Sub

        Private Function GetValue(ByVal Prompt As String) As String

            Console.Write(Prompt)
            Return Console.ReadLine

        End Function

        Private Sub DisplayResults(ByVal Result As Decimal)
            Console.WriteLine()

            Console.WriteLine("If you borrow {0:c}, ", decLoanAmount)
            Console.WriteLine("           at {0}% interest.", dblAnnualInterest)
            Console.WriteLine("          for {0} years", iYears)

            Console.WriteLine()
            Console.WriteLine("Your monthly payment would be: {0:c}", Result)

        End Sub

    End Module

End Namespace
