Option Strict On
Option Explicit On 

'***Demonstrates declaring, initializing and using various variable types
Namespace VB21.Day03

    Module modVariables
        '***Global Variable
        Public iTest As Integer

        '***Module level variable
        Private sValue As String

        '***Enumeration
        Enum DaysOfWeek
            dowMonday = 1
            dowTuesday
            dowWednesday
            dowThursday
            dowFriday
            dowSaturday
            dowSunday
        End Enum

        Public Sub Main()

            '***Simple declaration
            Dim iSomeNumber As Integer
            Dim sFirstName As String
            Dim decGrossDomesticProduct As Decimal
            Dim bLearned As Boolean

            '***Declaration with Initialization
            Dim dtDateOfMagnaCartaSigning As Date = #6/15/1215#
            Dim lPeopleOnEarth As Long = 6000000000

            '***Constants
            Const FOO As String = "Bar"

            '***Arrays
            'Simple declaration
            Dim iValues(3) As Integer
            Dim dtDates() As Date
            Dim I As Integer
            For I = 1 To 3
                iValues(I - 1) = I
            Next

            'Changing the size of an existing array
            ReDim dtDates(4)
            'fill the list of dates
            dtDates(0) = #6/15/1215# 'Signing of Magna Carta
            dtDates(1) = #8/28/1963# 'Martin Luther King Jr. delivers "I have a dream" speech
            dtDates(2) = #7/20/1969# 'Apollo 11 lands on Moon
            dtDates(3) = #2/14/1946# 'ENIAC (first large-scale computer) unveiled to public

            'Declaration with Initialization
            Dim sMonths() As String = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"}

            'Using arrays
            Console.WriteLine("")
            Console.WriteLine("Second value in iValues = {0}", iValues(1))
            Console.WriteLine("Third date in dtDates = {0}", dtDates(2))
            Console.WriteLine("Eleventh month of the year = {0}", sMonths(10))

        End Sub

    End Module

End Namespace
